﻿/*
【注意】
本スクリプトはドキュメントの内容を変更するスクリプトです。
一時的に「GREP」フォルダなどの名称を変更します。
必ずドキュメントや、各フォルダのバックアップをとってからご使用ください。

ドキュメントに存在しない設定（段落スタイル、文字スタイル、スウォッチなど）がクエリに含まれている場合、
アラートが表示されることなく意図しない結果になることがあります。
十分に各クエリを検証した上でご使用ください。

【ご使用にあたって】
クエリを収めたフォルダは「Find-Change Queries」内（「GREP」フォルダと同階層）に置いてください。
※「Find-Change Queries」については　https://helpx.adobe.com/jp/indesign/kb/cpsid_84488.html　を参照。

クエリを収めたフォルダの名称は「GREP〜」としてください（「GREP_A社の作業用」など）。

ドキュメントを表示した状態で実行してください。なお、アクティブドキュメントのみが処理対象となります。
*/

/////////////////////////////////////////////////////////

//ドキュメント確認（アクティブドキュメントのみが対象）
if(app.documents.length==0){
alert("ドキュメントを表示してから実行してください。")
exit();//スクリプト終了
}
if(app.documents.length!=1){
if (confirm("アクティブドキュメントのみが処理対象となります。")){
}else{
alert("終了します")
exit();//スクリプト終了
}
}

//実行の確認
if (confirm("【注意】ドキュメントに存在しない設定がクエリに含まれている場合、アラートが表示されることなく意図しない結果になることがあります。\nスクリプトを実行してよろしいですか？")){
}else{
alert("終了します")
exit();//スクリプト終了
}

//検索置換の条件を設定（必要があれば編集してください）
app.findChangeGrepOptions.includeLockedLayersForFind = true;//ロックされたレイヤーを含める
app.findChangeGrepOptions.includeLockedStoriesForFind = true;//ロックされたストーリーを含める
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含める
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含める
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含める
app.findChangeGrepOptions.kanaSensitive = true;//カナを区別する
app.findChangeGrepOptions.widthSensitive = true;//全角半角を区別する

app.findGrepPreferences=NothingEnum.NOTHING
app.changeGrepPreferences=NothingEnum.NOTHING
app.findGrepPreferences.findWhat=""
app.changeGrepPreferences.changeTo=""

//使用するフォルダをダイアログで選択
var folderObj = Folder.selectDialog(
"フォルダを選択してください",
app.scriptPreferences.scriptsFolder.parent.parent.fullName+"/Find-Change Queries"
); 

//フォルダのパスやフォルダ名を取得
if(folderObj){
var fldPthName=folderObj.fsName;//パスを含むフォルダ名
//alert(fldPthName);
if (fldPthName.match(/Find-Change Queries\/GREP/)) {  //フォルダの場所と名称を確認
//alert("マッチしました。");
}else{
alert("「Find-Change Queries」内の「GREP〜」という名称のフォルダを選択してください") 
exit();//スクリプト終了
}

var fldPth=folderObj.path;//フォルダのパス
//alert(fldPth);
var fldName=folderObj.name;//パスを含まないフォルダ名
//alert(fldName);
fldName2 = fldName.toString();  //デコードの準備
fldName3=File.decode(fldName2); //デコード

//実行の確認
if (confirm("「"+fldName3+"」内のクエリをすべて実行します")){
}else{
alert("終了します")
exit();//スクリプト終了
}

//ここからダイアログ（Window）の設定
var stAry = [ "ドキュメント" , "ストーリー" , "選択範囲" ];
var conf_obj = {};
var dlg = new Window('dialog', "検索対象を選択", undefined, {borderless: false});	//borderlessは上の帯の有無らしい

//ドロップダウンリストのエリア
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';

//ドロップダウンリスト11
var ddl11 = dlg.panel.add('dropdownlist',  [0,0,240,23], stAry);
ddl11.title = '検索：';
ddl11.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//buttonエリア
dlg.group = dlg.add('group');
var ok_btn = dlg.group.add('button', undefined,"OK", {name:'ok'});
var can_btn = dlg.group.add('button',undefined,"Cancel", {name:'cancel'});
ok_btn.onClick = function () {
dlg.close();
a = true;
}
can_btn.onClick = function () {
dlg.close();
a = false;
}
dlg.show();

if(a==false){exit()};   //キャンセルの場合は終了

//フォルダ名を変更（"GREP"フォルダ以外を選択した場合のみ）
if(fldName != "GREP"){
//オリジナルの"GREP"フォルダの名称を一時的に"GREP_ original_saved"に変更
var grepFolder = Folder(fldPth+"/GREP");
grepFolder.rename("GREP_ original_saved");
//選択したフォルダの名称を一時的に"GREP"に変更
folderObj.rename("GREP");
}

//エラー対策（参照→http://cat.adodtp.com/2016/08/23/?p=638）（オフ）
/*
Main()
 function Main(){
  app.doScript("doMain()",ScriptLanguage.JAVASCRIPT,[],UndoModes.fastEntireScript);
 }
function doMain(){
*/

//ロックされたアイテムがある場合、解除するか否かを確認
var mydoc = app.activeDocument;
var lokedItemsCount = 0;
for (n=0; n<mydoc.pageItems.length; n++){
if (mydoc.pageItems[n].locked == true){lokedItemsCount=lokedItemsCount+1}
}
if(lokedItemsCount != 0){
if (confirm("全アイテムのロックを解除してから実行しますか？\nロックしたままで実行する場合は「No」をクリック")){
//ロックを解除
mydoc.pageItems.everyItem().locked = false;
}else{
}
}

//"GREP"フォルダ内のクエリを確認
fileList = folderObj.getFiles();    //フォルダ内の全ファイルをゲット
//alert(fileList.length+"個のファイルがあります");

//GREPフォルダ内のクエリ（xmlファイル）をソート
var flName=new Array();
for(var t=0; t < fileList.length; t++){
if(fileList[t].name.match(/\.xml$/)){ 
flName.push(decodeURI("\r"+fileList[t].name))
}
flName.sort(function(a,b){
        if( a < b ) return -1;
        if( a > b ) return 1;
        return 0;
});
}
//alert(flName)
//alert(flName.length)

for(var s=0; s < flName.length; s++){
//alert(flName[s])
queryName = flName[s].replace(/\.xml/g,"");  //ファイル名から拡張子を除く
queryName2 = queryName.replace(/\r/g,"");
//alert(queryName2)
my_mode = SearchModes.GREP_SEARCH;  //検索モード（GREPに固定）
app.loadFindChangeQuery(queryName2, my_mode);   //クエリをロード

try {

//ドキュメント
if( ddl11.selection.index == 0 ){
mydoc.changeGrep();   //GREP置換を実行（ドキュメント）
}

//ストーリー
if( ddl11.selection.index == 1 ){
if(app.activeDocument.selection[0]==undefined){
    alert ("ストーリーを選択して実行してください。\nスクリプトをキャンセルしました。")
    exit();//スクリプト終了
}
app.activeDocument.selection[0].parentStory.changeGrep();   //GREP置換を実行（ストーリー）
}

//選択範囲
if( ddl11.selection.index == 2 ){
//alert(app.activeDocument.selection[0].contents.length)   
//alert(app.activeDocument.selection.length)   
if(app.activeDocument.selection.length==0){
    alert ("対象を選択して実行してください。\nスクリプトをキャンセルしました。")
    exit();//スクリプト終了
}
if(app.activeDocument.selection[0].contents.length==0){
    alert ("対象を選択して実行してください。\nスクリプトをキャンセルしました。")
    exit();//スクリプト終了
}
app.activeDocument.selection[0].changeGrep();   //GREP置換を実行（選択範囲）
}

}catch (e) {
alert("【エラー】ドキュメントに存在しない設定がクエリに含まれています。\nスクリプトをキャンセルしました。");
exit();//スクリプト終了
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.INTERACT_WITH_ALL;
}
}

//} ////////←エラー対策ココまで（オフ）

//後始末
if(fldName != "GREP"){  //フォルダ名を戻す（最初に"GREP"フォルダ以外を選択していた場合）
folderObj.rename(fldName);  //使用したフォルダの名称（この時点では"GREP"）を元に戻す
grepFolder.rename("GREP");  //"GREP_ original_saved"フォルダの名称を"GREP"に戻す
}

//検索置換設定をリセット
app.findGrepPreferences=NothingEnum.NOTHING
app.changeGrepPreferences=NothingEnum.NOTHING
app.findGrepPreferences.findWhat=""
app.changeGrepPreferences.changeTo=""
}